#include "math.hh"

double Li2(double x)
{
	double x_0 = -0.30;
	double x_1 = 0.25;
	double x_2 = 0.51;
	if (x == 1.) return ZETA2;
	if (x <= x_0)
	{ 
		double temp = log(fabs(1.0-x));
		return -Li2(-x/(1.0-x)) - temp*temp/2 ;
	}
	else if (x < x_1)
	{
		double z = - log(1.0-x);
		double temp = z*(1.0-z/4.0*(1.0-z/9.0*(1.0-z*z/100.0
			*(1.0-5.0*z*z/294.0*(1.0-7.0*z*z/360.0
				*(1.0-5.0*z*z/242.0*(1.0-7601.0*z*z/354900.0
					*(1.0-91.0*z*z/4146.0*(1.0-3617.0*z*z/161840.0)
						))))))));
		return temp;
	}
	else if (x < x_2) return - Li2(-x) + Li2(x*x)/2.0 ;
	else
	{
		return ZETA2 - Li2(1.0-x) - log(fabs(x))*log(fabs(1.0-x)) ; 
	}
}